#!/usr/bin/env python2
import os
import time
import json
import requests

#setting yun host
logDir = "/dxpark"
user = "park"
parkDir = "/dxpark/service/parkos"
frpDir = "/dxpark/service/frpc"

#host = "192.168.1.10"
host = "hmcity.dxpark.cn"
#host = "park.lcllcf.cn"
#host = "sxctc.hmcitypark.cn"


def updateParkos(vurl):
	try:
		print("begin download parkos update shell...")
		print(os.system("cd {} && wget -O update.sh {}".format(parkDir,vurl)))
		print("begin update parkos...")
		print(os.popen("sh {}/update.sh".format(parkDir)).read())
		print("parkos update download success...")
		print(os.popen("sh {}/stop.sh".format(parkDir)).read())
		print(os.popen("sh {}/stop.sh".format(parkDir)).read())
		print(os.popen("su - {} -c {}/install.sh".format(user,parkDir)).read())
		print(os.popen("su - {} -c {}/start.sh".format(user,parkDir)).read())
	except:
		print("end download parkos update shell error.")
# clear log
print(os.system("echo > %s/crontab.log" % logDir))
# begin
print("begin timer version check by %s" % time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time())))
# frpc restart
print("2>> begin frpc restart...")
while True:
	frpid = os.popen("ps -ef | grep frpc | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
	if frpid=='':
		frpid=0
	else:
		frpid=int(frpid)
	if frpid > 10 :
		print("begin stop frpc [%d]" % frpid)
		print(os.popen("kill -9 {}".format(frpid)).read())
	else:
		print("frpc is stoped...")
		break
print("frpc begin to starting...")
print(os.popen("su - {} -c {}/start.sh".format(user,frpDir)).read())
print("2>> end restart frpc...")

# parkos version check
print("3>> begin check parkos version...")
try:
	macadd = os.popen("cat /sys/class/net/*/address").read().replace(":","").split("\n")[0]
	print("parkos workmac is[%s]" % macadd)
	url = "http://"+host+"/dxparkapi/park/login/version/update"
	print(url)
	headers = {"content-type":"application/json","charset":"utf-8"}
	resp = requests.post(url, headers, {"mac":macadd,"type":1})
	respData = json.dumps(resp.json(), False)
	print("version resp:%s" % respData)
	respData = json.loads(respData)
	code = respData["status"]
	if code==0:
		newUrl = respData["data"]
		if newUrl=="":
			print("parkos has no version to update.")
		else:
			updateParkos(newUrl)
	else:
		msg = respData["msg"]
		print("check version msg:{}".format(msg))
except:
	print("check version error.")
print("3>> end check parkos version...")

# system time check
print("4>> begin check parkos version...")
print(os.popen("ntpdate -d ntp1.aliyun.com").read())
print("4>> end check parkos version...")

print("end timer version check by %s" % time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time())))
